View Issue Details

IDProjectCategoryView StatusLast Update
14150Bug reportsInstallationpublic2018-11-15 15:13
Reporterptramonti Assigned Toc_schmitz  
PrioritynoneSeverityminor 
Status closedResolutionfixed 
Fixed in Version3.16.x 
Summary14150: Wrong Survey menu id entry
DescriptionAfter a fresh installation I see that in the left panel of each surveys don't appear the submenus (see first attached image).
If I look on the db tables "lime_surveymenu" I see that the id field of the three menu (settings, mainmenu and quickmenu) are 5, 10 and 15 instead of 1, 2 and 3!
In the "lime_surveymenu_entries" table I see also that the field "menu_id" it's valued between 1, 2 and 3!
If I change in "lime_surveymenu" table the id value to 1, 2 and 3, then all the submenu appear in the survey!

We use MySql MariaDB Galera Cluster and so we have the following limitation:
https://mariadb.com/kb/en/library/mariadb-galera-cluster-known-limitations/
In particular:
- Do not rely on auto-increment values to be sequential. Galera uses a mechanism based on autoincrement increment to produce unique non-conflicting sequences, so on every single node the sequence will have gaps. See http://codership.blogspot.com/2009/02/managing-auto-increments-with-multi.html

If I look in the function getSurveyMenuEntryData() in \application\core\LsDefaultDataSets.php I see that the menu_id are hard coded between 1, 2 and 3.
The simplest solution is to modify the function getSurveyMenuData() to explicitly set the id of the menu data... I tried in this way and redo a fresh install and now all works fine!
In the secondo attached image you can see the simple changes to the code.

You should check if the problem also occurs in other tables (I don't think so) and in any case you have to take care of this in future developments.
Thanks
Steps To Reproduce1. Install Limesurvey 3.15.1 on a MariaDB Galera Cluster.
2. Create a Survey
3. The survey submenu below "Survey settings" and "Survey menu" on the left side panel don't appear.
TagsNo tags attached.
Complete LimeSurvey version number (& build)Version 3.15.1+181017
I will donate to the project if issue is resolvedNo
Browser
Database & DB-VersionMySql MariaDB Galera Cluster 5.5.5-10.1.36
Server OS (if known)ubuntu 16.04.1
Webserver software & version (if known)apache
PHP Version7.0.32.0.0.16.04.1

Activities

ptramonti

ptramonti

2018-10-18 17:08

reporter  

Menu without entries.png (17,725 bytes)   
Menu without entries.png (17,725 bytes)   
LsDefaultDataSets modified.png (37,117 bytes)   
LsDefaultDataSets modified.png (37,117 bytes)   
DenisChenu

DenisChenu

2018-10-19 09:23

developer   ~49366

Pull request can be done … There are no id set for default ??? Arg … pull request is easy then ;)
c_schmitz

c_schmitz

2018-10-19 15:48

administrator   ~49371

Fix committed to master branch: http://bugs.limesurvey.org/plugin.php?page=Source/view&id=28377
c_schmitz

c_schmitz

2018-10-19 15:49

administrator   ~49372

Thank you - good catch!

Related Changesets

LimeSurvey: master 87499dc5

2018-10-19 15:48:30

c_schmitz

Details Diff
Fixed issue 14150: Wrong survey menu id entry Affected Issues
14150
mod - application/core/LsDefaultDataSets.php Diff File

Issue History

Date Modified Username Field Change
2018-10-18 17:08 ptramonti New Issue
2018-10-18 17:08 ptramonti File Added: Menu without entries.png
2018-10-18 17:08 ptramonti File Added: LsDefaultDataSets modified.png
2018-10-19 09:23 DenisChenu Note Added: 49366
2018-10-19 15:48 c_schmitz Assigned To => c_schmitz
2018-10-19 15:48 c_schmitz Status new => assigned
2018-10-19 15:48 c_schmitz Changeset attached => LimeSurvey master 87499dc5
2018-10-19 15:48 c_schmitz Note Added: 49371
2018-10-19 15:48 c_schmitz Resolution open => fixed
2018-10-19 15:48 c_schmitz Status assigned => resolved
2018-10-19 15:48 c_schmitz Fixed in Version => 3.16.x
2018-10-19 15:49 c_schmitz Note Added: 49372
2018-11-15 15:13 dominikvitt Status resolved => closed